diff --git a/toolkit/crashreporter/google-breakpad/src/client/mac/tests/SimpleStringDictionaryTest.mm b/toolkit/crashreporter/google-breakpad/src/client/mac/tests/SimpleStringDictionaryTest.mm
new file mode 100644
--- /dev/null
+++ b/toolkit/crashreporter/google-breakpad/src/client/mac/tests/SimpleStringDictionaryTest.mm
@@ -0,0 +1,243 @@
+// Copyright (c) 2008, Google Inc.
+// All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+//
+//     * Redistributions of source code must retain the above copyright
+// notice, this list of conditions and the following disclaimer.
+//     * Redistributions in binary form must reproduce the above
+// copyright notice, this list of conditions and the following disclaimer
+// in the documentation and/or other materials provided with the
+// distribution.
+//     * Neither the name of Google Inc. nor the names of its
+// contributors may be used to endorse or promote products derived from
+// this software without specific prior written permission.
+//
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#import "SimpleStringDictionaryTest.h"
+#import "SimpleStringDictionary.h"
+
+using google_breakpad::KeyValueEntry;
+using google_breakpad::SimpleStringDictionary;
+using google_breakpad::SimpleStringDictionaryIterator;
+
+@implementation SimpleStringDictionaryTest
+
+//==============================================================================
+- (void)testKeyValueEntry {
+  KeyValueEntry entry;
+
+  // Verify that initial state is correct
+  STAssertFalse(entry.IsActive(), @"Initial key value entry is active!");
+  STAssertEquals(strlen(entry.GetKey()), (size_t)0, @"Empty key value did not "
+                 @"have length 0");
+  STAssertEquals(strlen(entry.GetValue()), (size_t)0, @"Empty key value did not "
+                 @"have length 0");
+
+  // Try setting a key/value and then verify
+  entry.SetKeyValue("key1", "value1");
+  STAssertEqualCStrings(entry.GetKey(), "key1", @"key was not equal to key1");
+  STAssertEqualCStrings(entry.GetValue(), "value1", @"value was not equal");
+
+  // Try setting a new value
+  entry.SetValue("value3");
+
+  // Make sure the new value took
+  STAssertEqualCStrings(entry.GetValue(), "value3", @"value was not equal");
+
+  // Make sure the key didn't change
+  STAssertEqualCStrings(entry.GetKey(), "key1", @"key changed after setting "
+                        @"value!");
+
+  // Try setting a new key/value and then verify
+  entry.SetKeyValue("key2", "value2");
+  STAssertEqualCStrings(entry.GetKey(), "key2", @"New key was not equal to "
+                        @"key2");
+  STAssertEqualCStrings(entry.GetValue(), "value2", @"New value was not equal "
+                        @"to value2");
+
+  // Clear the entry and verify the key and value are empty strings
+  entry.Clear();
+  STAssertFalse(entry.IsActive(), @"Key value clear did not clear object");
+  STAssertEquals(strlen(entry.GetKey()), (size_t)0, @"Length of cleared key "
+		 @"was not 0");
+  STAssertEquals(strlen(entry.GetValue()), (size_t)0, @"Length of cleared "
+		 @"value was not 0!");
+}
+
+- (void)testEmptyKeyValueCombos {
+  KeyValueEntry entry;
+  entry.SetKeyValue(NULL, NULL);
+  STAssertEqualCStrings(entry.GetKey(), "", @"Setting NULL key did not return "
+			@"empty key!");
+  STAssertEqualCStrings(entry.GetValue(), "", @"Setting NULL value did not "
+			@"set empty string value!");
+}
+
+
+//==============================================================================
+- (void)testSimpleStringDictionary {
+  // Make a new dictionary
+  SimpleStringDictionary *dict = new SimpleStringDictionary();
+  STAssertTrue(dict != NULL, nil);
+
+  // try passing in NULL for key
+  //dict->SetKeyValue(NULL, "bad");   // causes assert() to fire
+
+  // Set three distinct values on three keys
+  dict->SetKeyValue("key1", "value1");
+  dict->SetKeyValue("key2", "value2");
+  dict->SetKeyValue("key3", "value3");
+
+  STAssertTrue(!strcmp(dict->GetValueForKey("key1"), "value1"), nil);
+  STAssertTrue(!strcmp(dict->GetValueForKey("key2"), "value2"), nil);
+  STAssertTrue(!strcmp(dict->GetValueForKey("key3"), "value3"), nil);
+  STAssertEquals(dict->GetCount(), 3, @"GetCount did not return 3");
+  // try an unknown key
+  STAssertTrue(dict->GetValueForKey("key4") == NULL, nil);
+
+  // try a NULL key
+  //STAssertTrue(dict->GetValueForKey(NULL) == NULL, nil);  // asserts
+
+  // Remove a key
+  dict->RemoveKey("key3");
+
+  // Now make sure it's not there anymore
+  STAssertTrue(dict->GetValueForKey("key3") == NULL, nil);
+
+  // Remove a NULL key
+  //dict->RemoveKey(NULL);  // will cause assert() to fire
+
+  // Remove by setting value to NULL
+  dict->SetKeyValue("key2", NULL);
+
+  // Now make sure it's not there anymore
+  STAssertTrue(dict->GetValueForKey("key2") == NULL, nil);
+}
+
+//==============================================================================
+// The idea behind this test is to add a bunch of values to the dictionary,
+// remove some in the middle, then add a few more in.  We then create a
+// SimpleStringDictionaryIterator and iterate through the dictionary, taking
+// note of the key/value pairs we see.  We then verify that it iterates
+// through exactly the number of key/value pairs we expect, and that they
+// match one-for-one with what we would expect.  In all cases we're setting
+// key value pairs of the form:
+//
+// key<n>/value<n>   (like key0/value0, key17,value17, etc.)
+//
+- (void)testSimpleStringDictionaryIterator {
+  SimpleStringDictionary *dict = new SimpleStringDictionary();
+  STAssertTrue(dict != NULL, nil);
+
+  char key[KeyValueEntry::MAX_STRING_STORAGE_SIZE];
+  char value[KeyValueEntry::MAX_STRING_STORAGE_SIZE];
+
+  const int kDictionaryCapacity = SimpleStringDictionary::MAX_NUM_ENTRIES;
+  const int kPartitionIndex = kDictionaryCapacity - 5;
+
+  // We assume at least this size in the tests below
+  STAssertTrue(kDictionaryCapacity >= 64, nil);
+
+  // We'll keep track of the number of key/value pairs we think should
+  // be in the dictionary
+  int expectedDictionarySize = 0;
+
+  // Set a bunch of key/value pairs like key0/value0, key1/value1, ...
+  for (int i = 0; i < kPartitionIndex; ++i) {
+    sprintf(key, "key%d", i);
+    sprintf(value, "value%d", i);
+    dict->SetKeyValue(key, value);
+  }
+  expectedDictionarySize = kPartitionIndex;
+
+  // set a couple of the keys twice (with the same value) - should be nop
+  dict->SetKeyValue("key2", "value2");
+  dict->SetKeyValue("key4", "value4");
+  dict->SetKeyValue("key15", "value15");
+
+  // Remove some random elements in the middle
+  dict->RemoveKey("key7");
+  dict->RemoveKey("key18");
+  dict->RemoveKey("key23");
+  dict->RemoveKey("key31");
+  expectedDictionarySize -= 4;  // we just removed four key/value pairs
+
+  // Set some more key/value pairs like key59/value59, key60/value60, ...
+  for (int i = kPartitionIndex; i < kDictionaryCapacity; ++i) {
+    sprintf(key, "key%d", i);
+    sprintf(value, "value%d", i);
+    dict->SetKeyValue(key, value);
+  }
+  expectedDictionarySize += kDictionaryCapacity - kPartitionIndex;
+
+  // Now create an iterator on the dictionary
+  SimpleStringDictionaryIterator iter(*dict);
+
+  // We then verify that it iterates through exactly the number of
+  // key/value pairs we expect, and that they match one-for-one with what we
+  // would expect.  The ordering of the iteration does not matter...
+
+  // used to keep track of number of occurrences found for key/value pairs
+  int count[kDictionaryCapacity];
+  memset(count, 0, sizeof(count));
+
+  int totalCount = 0;
+
+  const KeyValueEntry *entry;
+
+  while ((entry = iter.Next())) {
+    totalCount++;
+
+    // Extract keyNumber from a string of the form key<keyNumber>
+    int keyNumber;
+    sscanf(entry->GetKey(), "key%d", &keyNumber);
+
+    // Extract valueNumber from a string of the form value<valueNumber>
+    int valueNumber;
+    sscanf(entry->GetValue(), "value%d", &valueNumber);
+
+    // The value number should equal the key number since that's how we set them
+    STAssertTrue(keyNumber == valueNumber, nil);
+
+    // Key and value numbers should be in proper range:
+    // 0 <= keyNumber < kDictionaryCapacity
+    bool isKeyInGoodRange =
+      (keyNumber >= 0 && keyNumber < kDictionaryCapacity);
+    bool isValueInGoodRange =
+      (valueNumber >= 0 && valueNumber < kDictionaryCapacity);
+    STAssertTrue(isKeyInGoodRange, nil);
+    STAssertTrue(isValueInGoodRange, nil);
+
+    if (isKeyInGoodRange && isValueInGoodRange) {
+      ++count[keyNumber];
+    }
+  }
+
+  // Make sure each of the key/value pairs showed up exactly one time, except
+  // for the ones which we removed.
+  for (int i = 0; i < kDictionaryCapacity; ++i) {
+    // Skip over key7, key18, key23, and key31, since we removed them
+    if (!(i == 7 || i == 18 || i == 23 || i == 31)) {
+      STAssertTrue(count[i] == 1, nil);
+    }
+  }
+
+  // Make sure the number of iterations matches the expected dictionary size.
+  STAssertTrue(totalCount == expectedDictionarySize, nil);
+}
+
+@end
diff --git a/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer.cc b/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer.cc
--- a/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer.cc
+++ b/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer.cc
@@ -32,43 +32,53 @@
 // See minidump_file_writer.h for documentation.
 
 #include <fcntl.h>
 #include <limits.h>
 #include <stdio.h>
 #include <string.h>
 #include <unistd.h>
 
+#include "common/linux/linux_syscall_support.h"
+#include "common/linux/linux_libc_support.h"
 #include "client/minidump_file_writer-inl.h"
 #include "common/string_conversion.h"
 
 namespace google_breakpad {
 
 const MDRVA MinidumpFileWriter::kInvalidMDRVA = static_cast<MDRVA>(-1);
 
 MinidumpFileWriter::MinidumpFileWriter() : file_(-1), position_(0), size_(0) {
 }
 
 MinidumpFileWriter::~MinidumpFileWriter() {
   Close();
 }
 
 bool MinidumpFileWriter::Open(const char *path) {
   assert(file_ == -1);
+#if __linux__
+  file_ = sys_open(path, O_WRONLY | O_CREAT | O_EXCL, 0600);
+#else
   file_ = open(path, O_WRONLY | O_CREAT | O_EXCL, 0600);
+#endif
 
   return file_ != -1;
 }
 
 bool MinidumpFileWriter::Close() {
   bool result = true;
 
   if (file_ != -1) {
     ftruncate(file_, position_);
+#if __linux__
+    result = (sys_close(file_) == 0);
+#else
     result = (close(file_) == 0);
+#endif
     file_ = -1;
   }
 
   return result;
 }
 
 bool MinidumpFileWriter::CopyStringToMDString(const wchar_t *str,
                                               unsigned int length,
@@ -222,19 +232,26 @@ bool MinidumpFileWriter::Copy(MDRVA posi
   assert(size);
   assert(file_ != -1);
 
   // Ensure that the data will fit in the allocated space
   if (size + position > size_)
     return false;
 
   // Seek and write the data
-  if (lseek(file_, position, SEEK_SET) == static_cast<off_t>(position))
-    if (write(file_, src, size) == size)
+#if __linux__
+  if (sys_lseek(file_, position, SEEK_SET) == static_cast<off_t>(position)) {
+    if (sys_write(file_, src, size) == size) {
+#else
+  if (lseek(file_, position, SEEK_SET) == static_cast<off_t>(position)) {
+    if (write(file_, src, size) == size) {
+#endif
       return true;
+    }
+  }
 
   return false;
 }
 
 bool UntypedMDRVA::Allocate(size_t size) {
   assert(size_ == 0);
   size_ = size;
   position_ = writer_->Allocate(size_);
diff --git a/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer_unittest.cc b/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer_unittest.cc
--- a/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer_unittest.cc
+++ b/toolkit/crashreporter/google-breakpad/src/client/minidump_file_writer_unittest.cc
@@ -121,27 +121,32 @@ static bool CompareFile(const char *path
     0x01000002, 0x00000003, 0x02000003, 0x00000004, 0x03000004, 0x00000005,
     0x04000005, 0x00000006, 0x05000006, 0x00000007, 0x06000007, 0x00000008,
     0x07000008, 0x00000009, 0x08000009, 0x0000000a, 0x0900000a, 0x0000000b,
     0x0000000a, 0x00000001, 0x00000002, 0x01000002, 0x00000003, 0x02000003,
     0x00000004, 0x03000004, 0x00000005, 0x04000005, 0x00000006, 0x05000006,
     0x00000007, 0x06000007, 0x00000008, 0x07000008, 0x00000009, 0x08000009,
     0x0000000a, 0x0900000a, 0x0000000b, 0x00000000
 #else
-    0x0000beef, 0x0000001e, 0x00000018, 0x00000020, 0x00000038, 0x00000000,
-    0x00000018, 0x00690046, 0x00730072, 0x00200074, 0x00740053, 0x00690072,
-    0x0067006e, 0x00000000, 0x0000001a, 0x00650053, 0x006f0063, 0x0064006e,
-    0x00530020, 0x00720074, 0x006e0069, 0x00000067, 0x0001da00, 0x00000002,
-    0x0002da01, 0x00000003, 0x0003da02, 0x00000004, 0x0004da03, 0x00000005,
-    0x0005da04, 0x00000006, 0x0006da05, 0x00000007, 0x0007da06, 0x00000008,
-    0x0008da07, 0x00000009, 0x0009da08, 0x0000000a, 0x000ada09, 0x0000000b,
-    0x0000000a, 0x00018700, 0x00000002, 0x00028701, 0x00000003, 0x00038702,
-    0x00000004, 0x00048703, 0x00000005, 0x00058704, 0x00000006, 0x00068705,
-    0x00000007, 0x00078706, 0x00000008, 0x00088707, 0x00000009, 0x00098708,
-    0x0000000a, 0x000a8709, 0x0000000b, 0x00000000, 
+    0x0000beef, 0x0000001e, 0x00000018, 0x00000020,
+    0x00000038, 0x00000000, 0x00000018, 0x00690046,
+    0x00730072, 0x00200074, 0x00740053, 0x00690072,
+    0x0067006e, 0x00000000, 0x0000001a, 0x00650053,
+    0x006f0063, 0x0064006e, 0x00530020, 0x00720074,
+    0x006e0069, 0x00000067, 0x00011e00, 0x00000002,
+    0x00021e01, 0x00000003, 0x00031e02, 0x00000004,
+    0x00041e03, 0x00000005, 0x00051e04, 0x00000006,
+    0x00061e05, 0x00000007, 0x00071e06, 0x00000008,
+    0x00081e07, 0x00000009, 0x00091e08, 0x0000000a,
+    0x000a1e09, 0x0000000b, 0x0000000a, 0x00011c00,
+    0x00000002, 0x00021c01, 0x00000003, 0x00031c02,
+    0x00000004, 0x00041c03, 0x00000005, 0x00051c04,
+    0x00000006, 0x00061c05, 0x00000007, 0x00071c06,
+    0x00000008, 0x00081c07, 0x00000009, 0x00091c08,
+    0x0000000a, 0x000a1c09, 0x0000000b, 0x00000000,
 #endif
   };
   unsigned int expected_byte_count = sizeof(expected);
   int fd = open(path, O_RDONLY, 0600);
   void *buffer = malloc(expected_byte_count);
   ASSERT_NE(fd, -1);
   ASSERT_TRUE(buffer);
   ASSERT_EQ(read(fd, buffer, expected_byte_count), expected_byte_count);
@@ -151,17 +156,16 @@ static bool CompareFile(const char *path
   b2 = (char*)expected;
   while (*b1 == *b2) {
     b1++;
     b2++;
   }
 
   printf("%d\n",b1 - (char*)buffer);
 
-
   ASSERT_EQ(memcmp(buffer, expected, expected_byte_count), 0);
   return true;
 }
 
 static bool RunTests() {
   const char *path = "/tmp/minidump_file_writer_unittest.dmp";
   ASSERT_TRUE(WriteFile(path));
   ASSERT_TRUE(CompareFile(path));
diff --git a/toolkit/crashreporter/google-breakpad/src/client/windows/breakpad_client.sln b/toolkit/crashreporter/google-breakpad/src/client/windows/breakpad_client.sln
--- a/toolkit/crashreporter/google-breakpad/src/client/windows/breakpad_client.sln
+++ b/toolkit/crashreporter/google-breakpad/src/client/windows/breakpad_client.sln
@@ -5,16 +5,18 @@ Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C9
 	ProjectSection(ProjectDependencies) = postProject
 		{A820AF62-6239-4693-8430-4F516C1838F4} = {A820AF62-6239-4693-8430-4F516C1838F4}
 	EndProjectSection
 EndProject
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "crash_report_sender", "sender\crash_report_sender.vcproj", "{9946A048-043B-4F8F-9E07-9297B204714C}"
 EndProject
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "crash_generation", "crash_generation\crash_generation.vcproj", "{A820AF62-6239-4693-8430-4F516C1838F4}"
 EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "exception_handler_test", "handler\exception_handler_test\exception_handler_test.vcproj", "{89094A11-CF25-4037-AF43-EACFA751405E}"
+EndProject
 Global
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
 		Debug|Win32 = Debug|Win32
 		DebugStaticCRT|Win32 = DebugStaticCRT|Win32
 		Release|Win32 = Release|Win32
 		ReleaseStaticCRT|Win32 = ReleaseStaticCRT|Win32
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
@@ -37,13 +39,21 @@ Global
 		{A820AF62-6239-4693-8430-4F516C1838F4}.Debug|Win32.ActiveCfg = Debug|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.Debug|Win32.Build.0 = Debug|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.DebugStaticCRT|Win32.ActiveCfg = DebugStaticCRT|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.DebugStaticCRT|Win32.Build.0 = DebugStaticCRT|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.Release|Win32.ActiveCfg = Release|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.Release|Win32.Build.0 = Release|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.ReleaseStaticCRT|Win32.ActiveCfg = ReleaseStaticCRT|Win32
 		{A820AF62-6239-4693-8430-4F516C1838F4}.ReleaseStaticCRT|Win32.Build.0 = ReleaseStaticCRT|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.Debug|Win32.ActiveCfg = Debug|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.Debug|Win32.Build.0 = Debug|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.DebugStaticCRT|Win32.ActiveCfg = Debug|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.DebugStaticCRT|Win32.Build.0 = Debug|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.Release|Win32.ActiveCfg = Release|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.Release|Win32.Build.0 = Release|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.ReleaseStaticCRT|Win32.ActiveCfg = Release|Win32
+		{89094A11-CF25-4037-AF43-EACFA751405E}.ReleaseStaticCRT|Win32.Build.0 = Release|Win32
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
 		HideSolutionNode = FALSE
 	EndGlobalSection
 EndGlobal
diff --git a/toolkit/crashreporter/google-breakpad/src/client/windows/common/ipc_protocol.h b/toolkit/crashreporter/google-breakpad/src/client/windows/common/ipc_protocol.h
--- a/toolkit/crashreporter/google-breakpad/src/client/windows/common/ipc_protocol.h
+++ b/toolkit/crashreporter/google-breakpad/src/client/windows/common/ipc_protocol.h
@@ -90,17 +90,17 @@ enum MessageTag {
   MESSAGE_TAG_NONE = 0,
   MESSAGE_TAG_REGISTRATION_REQUEST = 1,
   MESSAGE_TAG_REGISTRATION_RESPONSE = 2,
   MESSAGE_TAG_REGISTRATION_ACK = 3
 };
 
 struct CustomClientInfo {
   const CustomInfoEntry* entries;
-  int count;
+  size_t count;
 };
 
 // Message structure for IPC between crash client and crash server.
 struct ProtocolMessage {
   ProtocolMessage()
       : tag(MESSAGE_TAG_NONE),
         pid(0),
         dump_type(MiniDumpNormal),
diff --git a/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.cc b/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.cc
--- a/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.cc
+++ b/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.cc
@@ -124,16 +124,29 @@ CrashGenerationServer::CrashGenerationSe
     dump_generator_.reset(new MinidumpGenerator(*dump_path));
   }
 }
 
 CrashGenerationServer::~CrashGenerationServer() {
   // Indicate to existing threads that server is shutting down.
   shutting_down_ = true;
 
+  // Even if there are no current worker threads running, it is possible that
+  // an I/O request is pending on the pipe right now but not yet done. In fact,
+  // it's very likely this is the case unless we are in an ERROR state. If we
+  // don't wait for the pending I/O to be done, then when the I/O completes,
+  // it may write to invalid memory. AppVerifier will flag this problem too.
+  // So we disconnect from the pipe and then wait for the server to get into
+  // error state so that the pending I/O will fail and get cleared.
+  DisconnectNamedPipe(pipe_);
+  int num_tries = 100;
+  while (num_tries-- && server_state_ != IPC_SERVER_STATE_ERROR) {
+    Sleep(10);
+  }
+
   // Unregister wait on the pipe.
   if (pipe_wait_handle_) {
     // Wait for already executing callbacks to finish.
     UnregisterWaitEx(pipe_wait_handle_, INVALID_HANDLE_VALUE);
   }
 
   // Close the pipe to avoid further client connections.
   if (pipe_) {
@@ -200,22 +213,24 @@ bool CrashGenerationServer::Start() {
                                    TRUE,   // Manual reset.
                                    FALSE,  // Initially signaled.
                                    NULL);  // Name.
   if (!overlapped_.hEvent) {
     return false;
   }
 
   // Register a callback with the thread pool for the client connection.
-  RegisterWaitForSingleObject(&pipe_wait_handle_,
-                              overlapped_.hEvent,
-                              OnPipeConnected,
-                              this,
-                              INFINITE,
-                              kPipeIOThreadFlags);
+  if (!RegisterWaitForSingleObject(&pipe_wait_handle_,
+                                   overlapped_.hEvent,
+                                   OnPipeConnected,
+                                   this,
+                                   INFINITE,
+                                   kPipeIOThreadFlags)) {
+    return false;
+  }
 
   pipe_ = CreateNamedPipe(pipe_name_.c_str(),
                           kPipeAttr,
                           kPipeMode,
                           1,
                           kOutBufferSize,
                           kInBufferSize,
                           0,
@@ -624,16 +639,24 @@ bool CrashGenerationServer::RespondToCli
 
   return success || GetLastError() == ERROR_IO_PENDING;
 }
 
 // The server thread servicing the clients runs this method. The method
 // implements the state machine described in ReadMe.txt along with the
 // helper methods HandleXXXState.
 void CrashGenerationServer::HandleConnectionRequest() {
+  // If we are shutting doen then get into ERROR state, reset the event so more
+  // workers don't run and return immediately.
+  if (shutting_down_) {
+    server_state_ = IPC_SERVER_STATE_ERROR;
+    ResetEvent(overlapped_.hEvent);
+    return;
+  }
+
   switch (server_state_) {
     case IPC_SERVER_STATE_ERROR:
       HandleErrorState();
       break;
 
     case IPC_SERVER_STATE_INITIAL:
       HandleInitialState();
       break;
diff --git a/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.h b/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.h
--- a/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.h
+++ b/toolkit/crashreporter/google-breakpad/src/client/windows/crash_generation/crash_generation_server.h
@@ -236,17 +236,17 @@ class CrashGenerationServer {
 
   // Instance of a mini dump generator.
   scoped_ptr<MinidumpGenerator> dump_generator_;
 
   // State of the server in performing the IPC with the client.
   // Note that since we restrict the pipe to one instance, we
   // only need to keep one state of the server. Otherwise, server
   // would have one state per client it is talking to.
-  IPCServerState server_state_;
+  volatile IPCServerState server_state_;
 
   // Whether the server is shutting down.
   volatile bool shutting_down_;
 
   // Overlapped instance for async I/O on the pipe.
   OVERLAPPED overlapped_;
 
   // Message object used in IPC with the client.
